"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const cli_engine_command_1 = require("cli-engine-command");
const cli_ux_1 = require("cli-ux");
const plugins_1 = require("../../plugins");
const g = global;
const bin = g.config ? g.config.bin : 'heroku';
class PluginsUninstall extends cli_engine_command_1.Command {
    async run() {
        const [plugin] = this.argv;
        cli_ux_1.cli.action.start(`Uninstalling ${plugin}`);
        this.plugins = new plugins_1.Plugins(this.config);
        await this.plugins.uninstall(plugin);
    }
}
PluginsUninstall.topic = 'plugins';
PluginsUninstall.command = 'uninstall';
PluginsUninstall.args = [{ name: 'plugin', description: 'plugin name to uninstall', required: true }];
PluginsUninstall.aliases = ['plugins:unlink'];
PluginsUninstall.description = 'uninstalls or unlinks a plugin';
PluginsUninstall.help = `Example:
    $ ${bin} plugins:uninstall heroku-accounts
`;
exports.default = PluginsUninstall;
