/// <reference types="klaw" />
import assync = require('assync');
import { Help as CLICommandHelp } from 'cli-engine-command/lib/help';
import Heroku = require('cli-engine-heroku');
import { HTTP } from 'http-call';
import * as klaw from 'klaw';
import * as moment from 'moment';
import semver = require('semver');
import command = require('./command');
import help = require('./commands/help');
import file = require('./file');
import Hooks = require('./hooks');
import lock = require('./lock');
import notFound = require('./not_found');
import updater = require('./updater');
import util = require('./util');
import Plugins = require('./plugins');
import Builtin = require('./plugins/builtin');
import corePlugins = require('./plugins/core');
import pluginLegacy = require('./plugins/legacy');
import linkPlugins = require('./plugins/link');
import pluginManifest = require('./plugins/manifest');
import userPlugins = require('./plugins/user');
import yarn = require('./plugins/yarn');
declare const _default: {
    readonly CLICommandHelp: typeof CLICommandHelp;
    readonly HTTP: typeof HTTP;
    readonly moment: typeof moment;
    readonly rwlockfile: any;
    readonly klaw: (root: string, options?: klaw.Options | undefined) => klaw.Walker;
    readonly crossSpawn: any;
    readonly Heroku: typeof Heroku;
    readonly stripAnsi: (str: string) => string;
    readonly semver: typeof semver;
    readonly assync: <T>(items: assync.MaybePromise<T[]>) => assync.Assync<T>;
    readonly Help: typeof help.Help;
    readonly Hooks: typeof Hooks.Hooks;
    readonly Lock: typeof lock.Lock;
    readonly NotFound: typeof notFound.NotFound;
    readonly Updater: typeof updater.Updater;
    readonly util: typeof util;
    readonly file: typeof file;
    readonly Builtin: typeof Builtin.Builtin;
    readonly LinkPlugins: typeof linkPlugins.LinkPlugins;
    readonly Plugins: typeof Plugins.Plugins;
    readonly UserPlugins: typeof userPlugins.UserPlugins;
    readonly CorePlugins: typeof corePlugins.CorePlugins;
    readonly Yarn: typeof yarn.Yarn;
    readonly PluginManifest: typeof pluginManifest.PluginManifest;
    readonly PluginLegacy: typeof pluginLegacy.PluginLegacy;
    readonly CommandManager: typeof command.CommandManager;
};
export default _default;
