"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = {
    // remote
    get CLICommandHelp() { return require('cli-engine-command/lib/help').Help; },
    get HTTP() { return fetch('http-call').HTTP; },
    get moment() { return fetch('moment'); },
    get rwlockfile() { return fetch('rwlockfile'); },
    get klaw() { return fetch('klaw'); },
    get crossSpawn() { return fetch('cross-spawn'); },
    get Heroku() { return fetch('cli-engine-heroku'); },
    get stripAnsi() { return fetch('strip-ansi'); },
    get semver() { return fetch('semver'); },
    get assync() { return fetch('assync').default; },
    // local
    get Help() { return fetch('./commands/help').default; },
    get Hooks() { return fetch('./hooks').Hooks; },
    get Lock() { return fetch('./lock').Lock; },
    get NotFound() { return fetch('./not_found').default; },
    get Updater() { return fetch('./updater').Updater; },
    get util() { return fetch('./util'); },
    get file() { return fetch('./file'); },
    // plugins
    get Builtin() { return fetch('./plugins/builtin').Builtin; },
    get LinkPlugins() { return fetch('./plugins/link').LinkPlugins; },
    get Plugins() { return fetch('./plugins').Plugins; },
    get UserPlugins() { return fetch('./plugins/user').UserPlugins; },
    get CorePlugins() { return fetch('./plugins/core').CorePlugins; },
    get Yarn() { return fetch('./plugins/yarn').default; },
    get PluginManifest() { return fetch('./plugins/manifest').PluginManifest; },
    get PluginLegacy() { return fetch('./plugins/legacy').PluginLegacy; },
    get CommandManager() { return fetch('./command').CommandManager; },
};
const cache = {};
function fetch(s) {
    if (!cache[s]) {
        cache[s] = require(s);
    }
    return cache[s];
}
