import { IConfig } from 'cli-engine-config';
import { ICommandInfo } from './command';
import { IPluginModule, IPluginPJSON } from './plugins/plugin';
export declare abstract class Hook<T extends keyof IHooks> {
    protected config: IConfig;
    constructor(config: IConfig);
    abstract run(options: IHooks[T]): Promise<void>;
}
export interface IHooks {
    init: {};
    update: {};
    'plugins:parse': {
        module: IPluginModule;
        pjson: IPluginPJSON;
    };
    prerun: {
        Command: ICommandInfo;
        argv: string[];
    };
}
export declare class Hooks {
    private config;
    constructor(config: IConfig);
    run<T extends keyof IHooks>(event: T, options?: IHooks[T]): Promise<void>;
    private isLegacyHook<T>(Hook);
}
