"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const deps_1 = require("./deps");
const debug = require('debug')('cli:hooks');
class Hook {
    constructor(config) {
        this.config = config;
    }
}
exports.Hook = Hook;
class Hooks {
    constructor(config) {
        this.config = config;
    }
    async run(event, options = {}) {
        let scripts = this.config.hooks[event];
        if (!scripts)
            return;
        for (let script of scripts) {
            script = path.join(this.config.root, script);
            debug(`%s %s`, event, script);
            const Hook = deps_1.default.util.undefault(require(script));
            if (this.isLegacyHook(Hook)) {
                await Hook(this.config, options);
            }
            else {
                const hook = new Hook(this.config);
                await hook.run(options);
            }
        }
    }
    isLegacyHook(Hook) {
        return !Hook.prototype;
    }
}
exports.Hooks = Hooks;
