"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const cli_engine_config_1 = require("cli-engine-config");
const path = require("path");
const hooks_1 = require("./hooks");
let init = (options = {}) => {
    process.env.RAN_HOOK = '0';
    let config = cli_engine_config_1.buildConfig(options);
    return new hooks_1.Hooks(config);
};
test('does not error when no hooks', async () => {
    let hooks = init();
    await hooks.run('init');
});
test('fires a hook', async () => {
    let hooks = init({
        root: path.join(__dirname, '..'),
        hooks: {
            init: ['test/fixtures/hooks/prerun.js'],
        },
    });
    await hooks.run('init');
    expect(process.env.RAN_HOOK).toEqual('1');
});
