"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const plugin_1 = require("./plugin");
class CorePlugins {
    constructor(config) {
        this.config = config;
    }
    async submanagers() {
        await this.init();
        return this.plugins;
    }
    async init() {
        if (this.plugins)
            return;
        this.plugins = this.config.corePlugins.map(name => new CorePlugin({
            root: path.join(this.config.root, 'node_modules', name),
            config: this.config,
        }));
    }
}
exports.CorePlugins = CorePlugins;
class CorePlugin extends plugin_1.Plugin {
    constructor() {
        super(...arguments);
        this.type = 'core';
    }
}
exports.CorePlugin = CorePlugin;
