import { IConfig } from 'cli-engine-config';
import { Plugin, PluginType } from './plugin';
export interface IManifestPlugin {
    name: string;
    root: string;
}
export declare class LinkPlugins {
    private config;
    plugins: LinkPlugin[];
    private manifest;
    private lock;
    private debug;
    constructor(config: IConfig);
    install(root: string): Promise<void>;
    findByRoot(root: string): Promise<LinkPlugin | undefined>;
    submanagers(): Promise<LinkPlugin[]>;
    init(): Promise<void>;
    private migrate();
    private addPlugin(name, root);
    private loadPlugin(root);
}
export declare class LinkPlugin extends Plugin {
    type: PluginType;
    private manifest;
    resetCache(): Promise<void>;
    refresh(force?: boolean): Promise<void>;
    init(): Promise<void>;
    private refreshType();
    private updateNodeModulesNeeded();
    private prepareNeeded();
    private updateNodeModules();
    private prepare();
    private lastUpdated();
}
