export interface IManifestOpts {
    file: string;
    invalidate?: string;
    name: string;
}
export declare class PluginManifest {
    needsSave: boolean;
    file: string;
    invalidate: string | undefined;
    name: string;
    private body;
    private mtime?;
    private saving?;
    private debug;
    constructor(opts: IManifestOpts);
    save(): Promise<void>;
    fetch<T>(key: string, fn: () => Promise<T>): Promise<T>;
    get(key: string): Promise<any>;
    set(key: string, v: any): Promise<any>;
    reset(): Promise<void>;
    private init();
    private read();
    private canWrite();
    private getLastUpdated();
}
