import { IConfig } from 'cli-engine-config';
import { IPluginOptions, Plugin, PluginType } from './plugin';
export declare class UserPlugins {
    private config;
    plugins: UserPlugin[];
    private manifest;
    private lock;
    private debug;
    constructor(config: IConfig);
    submanagers(): Promise<UserPlugin[]>;
    update(): Promise<void>;
    install(name: string, tag: string): Promise<void>;
    uninstall(name: string): Promise<void>;
    needsRefresh(): Promise<boolean>;
    refresh(): Promise<void>;
    init(): Promise<void>;
    private loadPlugin(name, tag);
    private userPluginPath(name);
    private readonly userPluginsDir;
    private readonly pjsonPath;
    private yarn();
    private createPJSON();
    private migrate();
    private addPlugin(name, tag);
}
export declare type UserPluginOptions = IPluginOptions & {
    tag: string;
};
export declare class UserPlugin extends Plugin {
    type: PluginType;
    tag: string;
    constructor(opts: UserPluginOptions);
}
