import { IConfig } from 'cli-engine-config';
import deps from './deps';
import { Lock } from './lock';
export interface IVersion {
    version: string;
    channel: string;
    message?: string;
}
export interface IManifest {
    version: string;
    channel: string;
    sha256gz: string;
}
export declare class Updater {
    config: IConfig;
    lock: Lock;
    http: typeof deps.HTTP;
    private _binPath;
    constructor(config: IConfig);
    readonly autoupdatefile: string;
    readonly autoupdatelogfile: string;
    readonly versionFile: string;
    private readonly clientRoot;
    private readonly clientBin;
    private readonly binPath;
    s3url(channel: string, p: string): string;
    fetchManifest(channel: string): Promise<IManifest>;
    fetchVersion(download: boolean): Promise<IVersion>;
    warnIfUpdateAvailable(): Promise<void>;
    autoupdate(force?: boolean): Promise<void>;
    update(manifest: IManifest): Promise<void>;
    tidy(): Promise<void>;
    private extract(stream, dir, sha);
    private _rename(from, to);
    private _remove(dir);
    private _mkdirp(dir);
    private base(manifest);
    private autoupdateNeeded();
    readonly timestampEnvVar: string;
    readonly skipAnalyticsEnvVar: string;
    readonly autoupdateEnv: {
        [k: string]: string;
    };
    private spawnBinPath(binPath, args, options);
    private _createBin(manifest);
    private _catch(fn);
}
